# Реализация CLI Яндекс.Облака для OneScript

## Информация
Библиотека предоставляет возможность взаимодействия с [CLI Яндекс.Облака](https://cloud.yandex.ru/docs/cli/) на языке OneScript.

## Установка

### CLI Яндекс.Облака

- [Установка CLI Яндекс.Облака](https://cloud.yandex.ru/docs/cli/quickstart#install)
- [Создание профиля CLI Яндекс.Облака и первоначальные настройки](https://cloud.yandex.ru/docs/cli/quickstart#initialize)

### OneScript

Для работы библиотеки **oscript-yacloud** необходимо предварительно установить [Стандартную библиотеку скриптов](http://oscript.io/library) OneScript.

```
opm install yacloud
```

## Использование

### Cloud

1. Общие методы работы с облаком расположены в модуле **ОблакоYC**
2. Для работы CLI Яндекс.Облака требуется авторизоваться с использованием методов:

    ```
    СтрокаOAuthToken = ПодключениеYC.ПрочитатьOAuthTken("OAuthToken");
    ПодключениеYC.ВыполнитьПодключение(СтрокаOAuthToken);
    ```
    - OAuthToken - текстовый файл с токеном
    - СтрокаOAuthToken - строковое представление токена

### Compute Cloud

1. Подготовка к созданию виртуальной машины

    1.1 Создать [файл авторизации](/template/cloud/сomputeсloud/authorization)

    1.2 Создать [конфигурационный файл](/template/cloud/сomputeсloud)
   - **КлючАвторизации**
     - **ПутьКФайлу** - путь к ранее соозданному файлу для авторизации к ВМ;
       - [MetadataLinux](/template/cloud/сomputeсloud/authorization/MetadataLinux.yaml)
       - [MetadataWindows](/template/cloud/сomputeсloud/authorization/MetadataWindows.yaml)
    - **ЗонаДоступности** - зона в которой расположена виртуальная сеть. Все существующие виртуальные сети можно получить с помощью метода:
        ```
        ОблакоYC.ПолучитьСписокПодсетей();
        ```
   - **ОбъемОперативнойПамятиГБ** - объем оперативной памяти;
   - **КоличествоЯдер** - количество виртуальных ядер;
   - **ГарантированнаяДоляПроцессора** - гарантированная доля процессора в процентах. (5, 20, 50, 100);
   - **Прерываемая** - признак определяет будет ли ВМ прерываемой;
   - **ЗагрузочныйДиск**
     - **ИмяДиска** - имя диска;
     - **ТипДиска** - "network-hdd" или "network-ssd";
     - **ОбъемГб** - объем в ГБ;
     - **ИмяСтандартногоОбраза** - имя образа который будет развенут. Все имеющиеся образы можно получить с помощью метода:
      ```
      ОблакоYC.ПолучитьСписокПубличныхОбразов();
      ```
   - **ВиртуальнаяСеть**
     - **ИмяСети** - имя ранее созданной виртуальной сети; 
     - **IPv4Адрес** - IP адрес в виртуальной сети;
     - **ИспользоватьДинамическийIP** - признак использования ранее созданного динамического IP адреса;
     - **ПубличныйСтатическийIP** - предопределенный публичный IP адрес. Данный параметр приоритетнее параметра ИспользоватьДинамическийIP.
2. Пример полного цикла жизни виртуальной машины:
    ```
    #Использовать yacloud

    // Выполняю подключение
    СтрокаOAuthToken = ПодключениеYC.ПрочитатьOAuthTken("OAuthToken");
    ПодключениеYC.ВыполнитьПодключение(СтрокаOAuthToken);

    // Создаю новую виртуальную машину
    ВиртуальнаяМашинаYC = Новый ВиртуальнаяМашинаYC("docker-01");
    ВиртуальнаяМашинаYC.Создать("./cloud/сomputeсloud/linux.xml");

    // Получаю свойства ранее созданной виртуальной машины
    ВиртуальнаяМашинаYC.Свойства();
    Сообщить(ВиртуальнаяМашинаYC.IPАдресВнешний());

    // Выполняю действия над машиной
    ОблакоYC.ПолучитьСписокВиртуальныхМашин();
    ВиртуальнаяМашинаYC.Остановить();
    ВиртуальнаяМашинаYC.Запустить();
    ВиртуальнаяМашинаYC.Перезапустить();
    ВиртуальнаяМашинаYC.Удалить();
    ```

## License
[MIT](https://choosealicense.com/licenses/mit/).
Использование сервиса Платформы Яндекс.Облако регламентируется [Условиями использования сервиса "Платформа Яндекс.Облако"](https://yandex.ru/legal/cloud_termsofuse/) (https://cloud.yandex.ru/docs/cli/).
